diff --git a/flist.c b/flist.c
--- a/flist.c
+++ b/flist.c
@@ -55,6 +55,7 @@ extern int preserve_devices;
 extern int preserve_specials;
 extern int delete_during;
 extern int missing_args;
+extern int use_db;
 extern int eol_nulls;
 extern int atimes_ndx;
 extern int crtimes_ndx;
@@ -1394,11 +1395,8 @@ struct file_struct *make_file(const char *fname, struct file_list *flist,
 		extra_len += EXTRA_LEN;
 #endif
 
-	if (always_checksum && am_sender && S_ISREG(st.st_mode)) {
-		file_checksum(thisname, &st, tmp_sum);
-		if (sender_keeps_checksum)
-			extra_len += SUM_EXTRA_CNT * EXTRA_LEN;
-	}
+	if (sender_keeps_checksum && S_ISREG(st.st_mode))
+		extra_len += SUM_EXTRA_CNT * EXTRA_LEN;
 
 #if EXTRA_ROUNDING > 0
 	if (extra_len & (EXTRA_ROUNDING * EXTRA_LEN))
@@ -1487,8 +1485,12 @@ struct file_struct *make_file(const char *fname, struct file_list *flist,
 		return NULL;
 	}
 
-	if (sender_keeps_checksum && S_ISREG(st.st_mode))
-		memcpy(F_SUM(file), tmp_sum, flist_csum_len);
+	if (always_checksum && am_sender && S_ISREG(st.st_mode)) {
+		if (!use_db || !db_get_checksum(&st, tmp_sum))
+			file_checksum(thisname, &st, tmp_sum);
+		if (sender_keeps_checksum)
+			memcpy(F_SUM(file), tmp_sum, flist_csum_len);
+	}
 
 	if (unsort_ndx)
 		F_NDX(file) = stats.num_dirs;
@@ -2172,6 +2174,9 @@ void send_extra_file_list(int f, int at_least)
   finish:
 	if (io_error != save_io_error && protocol_version == 30 && !ignore_errors)
 		send_msg_int(MSG_IO_ERROR, io_error);
+
+	if (use_db && flist_eof)
+		db_disconnect(True);
 }
 
 struct file_list *send_file_list(int f, int argc, char *argv[])
@@ -2195,6 +2200,13 @@ struct file_list *send_file_list(int f, int argc, char *argv[])
 		     | (eol_nulls || reading_remotely ? RL_EOL_NULLS : 0);
 	int implied_dot_dir = 0;
 
+	if (use_db) {
+		if (always_checksum)
+			db_connect(0); /* Will reset use_db on error. */
+		else
+			use_db = 0;
+	}
+
 	rprintf(FLOG, "building file list\n");
 	if (show_filelist_progress)
 		start_filelist_progress("building file list");
@@ -2540,6 +2552,9 @@ struct file_list *send_file_list(int f, int argc, char *argv[])
 			rprintf(FINFO, "[%s] flist_eof=1\n", who_am_i());
 	}
 
+	if (use_db && (!inc_recurse || flist_eof))
+		db_disconnect(True);
+
 	return flist;
 }
 
diff --git a/generator.c b/generator.c
--- a/generator.c
+++ b/generator.c
@@ -63,6 +63,7 @@ extern int ignore_non_existing;
 extern int want_xattr_optim;
 extern int modify_window;
 extern int inplace;
+extern int use_db;
 extern int append_mode;
 extern int make_backups;
 extern int csum_length;
@@ -626,6 +627,8 @@ int quick_check_ok(enum filetype ftype, const char *fn, struct file_struct *file
 		if (always_checksum > 0) {
 			char sum[MAX_DIGEST_LEN];
 			file_checksum(fn, st, sum);
+			if (!use_db || !db_get_checksum(st, sum))
+				file_checksum(fn, st, sum);
 			return memcmp(sum, F_SUM(file), flist_csum_len) == 0;
 		}
 
@@ -2270,6 +2273,13 @@ void generate_files(int f_out, const char *local_name)
 			: "enabled");
 	}
 
+	if (use_db) {
+		if (always_checksum || (append_mode != 1 && protocol_version >= 30))
+			db_connect(0); /* Will reset use_db on error. */
+		else
+			use_db = 0;
+	}
+
 	dflt_perms = (ACCESSPERMS & ~orig_umask);
 
 	do {
@@ -2395,6 +2405,9 @@ void generate_files(int f_out, const char *local_name)
 			wait_for_receiver();
 	}
 
+	if (use_db)
+		db_disconnect(True);
+
 	info_levels[INFO_FLIST] = save_info_flist;
 	info_levels[INFO_PROGRESS] = save_info_progress;
 
diff --git a/io.c b/io.c
--- a/io.c
+++ b/io.c
@@ -41,8 +41,10 @@ extern int am_server;
 extern int am_sender;
 extern int am_receiver;
 extern int am_generator;
+extern int local_server;
 extern int msgs2stderr;
 extern int inc_recurse;
+extern int same_db;
 extern int io_error;
 extern int batch_fd;
 extern int eol_nulls;
@@ -1513,6 +1515,32 @@ static void read_a_msg(void)
 		if (am_sender)
 			maybe_send_keepalive(time(NULL), MSK_ALLOW_FLUSH);
 		break;
+	case MSG_CHECKSUM:
+		/* This receives some checksum info that we want to make a note of
+		 * (which allows a single process to do all the writing to the db). */
+		if (msg_bytes != MSG_CHECKSUM_LEN)
+			goto overflow;
+		raw_read_buf(data, MSG_CHECKSUM_LEN);
+		if (am_generator && same_db) {
+			iobuf.in_multiplexed = 1;
+			send_msg(MSG_CHECKSUM, data, MSG_CHECKSUM_LEN, 0);
+		} if (am_receiver || (am_sender && !local_server))
+			goto unexpected;
+		else {
+			/* The received data is a set of numbers followed by the checksum. */
+			STRUCT_STAT st;
+			st.st_dev = IVAL64(data, 0);
+			st.st_ino = IVAL64(data, 8);
+			st.st_size = IVAL64(data, 16);
+			st.st_mtime = IVAL64(data, 24);
+			st.st_ctime = IVAL64(data, 32);
+#if MSG_CHECKSUM_LONGS != 5
+#error Fix the parsing of checksum long values
+#endif
+			iobuf.in_multiplexed = 1;
+			db_set_checksum(IVAL(data, MSG_CHECKSUM_LONGS*8), &st, data + MSG_CHECKSUM_LONGS*8 + 4);
+		}
+		break;
 	case MSG_DELETED:
 		if (msg_bytes >= sizeof data)
 			goto overflow;
@@ -1666,6 +1694,7 @@ static void read_a_msg(void)
 		 * with a duplicate exit message. */
 		_exit_cleanup(val, __FILE__, 0 - __LINE__);
 	default:
+	unexpected:
 		rprintf(FERROR, "unexpected tag %d [%s%s]\n",
 			tag, who_am_i(), inc_recurse ? "/inc" : "");
 		exit_cleanup(RERR_STREAMIO);
diff --git a/main.c b/main.c
--- a/main.c
+++ b/main.c
@@ -39,6 +39,7 @@ extern int am_root;
 extern int am_server;
 extern int am_sender;
 extern int am_daemon;
+extern int am_dbadmin;
 extern int inc_recurse;
 extern int blocking_io;
 extern int always_checksum;
@@ -58,6 +59,7 @@ extern int copy_unsafe_links;
 extern int keep_dirlinks;
 extern int preserve_hard_links;
 extern int protocol_version;
+extern int always_checksum;
 extern int mkpath_dest_arg;
 extern int file_total;
 extern int recurse;
@@ -95,6 +97,7 @@ extern char *logfile_format;
 extern char *filesfrom_host;
 extern char *partial_dir;
 extern char *rsync_path;
+extern char *db_config;
 extern char *shell_cmd;
 extern char *password_file;
 extern char *backup_dir;
@@ -1237,6 +1240,9 @@ void start_server(int f_in, int f_out, int argc, char *argv[])
 	if (am_daemon && io_timeout && protocol_version >= 31)
 		send_msg_int(MSG_IO_TIMEOUT, io_timeout);
 
+	if (db_config)
+		db_read_config(FERROR, db_config);
+
 	if (am_sender) {
 		keep_dirlinks = 0; /* Must be disabled on the sender. */
 		if (need_messages_from_generator)
@@ -1531,6 +1537,9 @@ static int start_client(int argc, char *argv[])
 	else
 		env_port = rsync_port;
 
+	if (db_config)
+		db_read_config(FERROR, db_config);
+
 	if (daemon_connection < 0)
 		return start_socket_client(shell_machine, remote_argc, remote_argv, argc, argv);
 
diff --git a/options.c b/options.c
--- a/options.c
+++ b/options.c
@@ -87,6 +87,7 @@ int am_root = 0; /* 0 = normal, 1 = root, 2 = --super, -1 = --fake-super */
 int am_server = 0;
 int am_sender = 0;
 int am_starting_up = 1;
+int am_dbadmin = 0;
 int relative_paths = -1;
 int implied_dirs = 1;
 int missing_args = 0; /* 0 = FERROR_XFER, 1 = ignore, 2 = delete */
@@ -101,6 +102,7 @@ int use_qsort = 0;
 char *files_from = NULL;
 int filesfrom_fd = -1;
 char *filesfrom_host = NULL;
+char *db_config = NULL;
 int eol_nulls = 0;
 int protect_args = -1;
 int old_style_args = -1;
@@ -110,6 +112,9 @@ int mkpath_dest_arg = 0;
 int allow_inc_recurse = 1;
 int xfer_dirs = -1;
 int am_daemon = 0;
+int db_clean, db_check, db_do_md4, db_do_md5, db_update = 1, db_lax, db_init, db_mounts;
+int db_output_name, db_output_sum, db_output_info, db_output_unchanged, db_output_dirs, db_output_msgs;
+int saw_db_output_opt, saw_db_sum_opt;
 int connect_timeout = 0;
 int keep_partial = 0;
 int safe_symlinks = 0;
@@ -289,6 +294,7 @@ static struct output_struct debug_words[COUNT_DEBUG+1] = {
 	DEBUG_WORD(CHDIR, W_CLI|W_SRV, "Debug when the current directory changes"),
 	DEBUG_WORD(CONNECT, W_CLI, "Debug connection events (levels 1-2)"),
 	DEBUG_WORD(CMD, W_CLI, "Debug commands+options that are issued (levels 1-2)"),
+	DEBUG_WORD(DB, W_SND|W_REC, "Debug DB operations (levels 1-5)"),
 	DEBUG_WORD(DEL, W_REC, "Debug delete actions (levels 1-3)"),
 	DEBUG_WORD(DELTASUM, W_SND|W_REC, "Debug delta-transfer checksumming (levels 1-4)"),
 	DEBUG_WORD(DUP, W_REC, "Debug weeding of duplicate names"),
@@ -578,6 +584,7 @@ enum {OPT_SERVER = 1000, OPT_DAEMON, OPT_SENDER, OPT_EXCLUDE, OPT_EXCLUDE_FROM,
       OPT_INCLUDE, OPT_INCLUDE_FROM, OPT_MODIFY_WINDOW, OPT_MIN_SIZE, OPT_CHMOD,
       OPT_READ_BATCH, OPT_WRITE_BATCH, OPT_ONLY_WRITE_BATCH, OPT_MAX_SIZE,
       OPT_NO_D, OPT_APPEND, OPT_NO_ICONV, OPT_INFO, OPT_DEBUG, OPT_BLOCK_SIZE,
+      OPT_NO_DB, OPT_DBONLY,
       OPT_USERMAP, OPT_GROUPMAP, OPT_CHOWN, OPT_BWLIMIT, OPT_STDERR,
       OPT_OLD_COMPRESS, OPT_NEW_COMPRESS, OPT_NO_COMPRESS, OPT_OLD_ARGS,
       OPT_STOP_AFTER, OPT_STOP_AT,
@@ -735,6 +742,10 @@ static struct poptOption long_options[] = {
   {"no-c",             0,  POPT_ARG_VAL,    &always_checksum, 0, 0, 0 },
   {"checksum-choice",  0,  POPT_ARG_STRING, &checksum_choice, 0, 0, 0 },
   {"cc",               0,  POPT_ARG_STRING, &checksum_choice, 0, 0, 0 },
+  {"db",               0,  POPT_ARG_STRING, &db_config, 0, 0, 0 },
+  {"no-db",            0,  POPT_ARG_NONE,   0, OPT_NO_DB, 0, 0 },
+  {"db-lax",           0,  POPT_ARG_VAL,    &db_lax, 1, 0, 0 },
+  {"no-db-lax",        0,  POPT_ARG_VAL,    &db_lax, 0, 0, 0 },
   {"block-size",      'B', POPT_ARG_STRING, 0, OPT_BLOCK_SIZE, 0, 0 },
   {"compare-dest",     0,  POPT_ARG_STRING, 0, OPT_COMPARE_DEST, 0, 0 },
   {"copy-dest",        0,  POPT_ARG_STRING, 0, OPT_COPY_DEST, 0, 0 },
@@ -834,6 +845,9 @@ static struct poptOption long_options[] = {
   {"dparam",           0,  POPT_ARG_STRING, 0, OPT_DAEMON, 0, 0 },
   {"detach",           0,  POPT_ARG_NONE,   0, OPT_DAEMON, 0, 0 },
   {"no-detach",        0,  POPT_ARG_NONE,   0, OPT_DAEMON, 0, 0 },
+  /* All the following options switch us into DB-admin option-parsing. */
+  {"db-help",          0,  POPT_ARG_NONE,   0, OPT_DBONLY, 0, 0 },
+  {"db-only",          0,  POPT_ARG_STRING, 0, OPT_DBONLY, 0, 0 },
   {0,0,0,0, 0, 0, 0}
 };
 
@@ -862,6 +876,31 @@ static struct poptOption long_daemon_options[] = {
   {0,0,0,0, 0, 0, 0}
 };
 
+static struct poptOption long_dbonly_options[] = {
+  /* longName, shortName, argInfo, argPtr, value, descrip, argDesc */
+  {"check",           'c', POPT_ARG_NONE,   &db_check, 0, 0, 0},
+  {"clean",            0,  POPT_ARG_NONE,   &db_clean, 0, 0, 0},
+  {"db",               0,  POPT_ARG_STRING, &db_config, 0, 0, 0 },
+  {"db-only",          0,  POPT_ARG_STRING, &db_config, 0, 0, 0 },
+  {"db-lax",           0,  POPT_ARG_VAL,    &db_lax, 1, 0, 0 },
+  {"no-db-lax",        0,  POPT_ARG_VAL,    &db_lax, 0, 0, 0 },
+  {"info",             0,  POPT_ARG_STRING, 0, OPT_INFO, 0, 0 },
+  {"debug",            0,  POPT_ARG_STRING, 0, OPT_DEBUG, 0, 0 },
+  {"update",          'u', POPT_ARG_VAL,    &db_update, 1, 0, 0 },
+  {"no-update",       'N', POPT_ARG_VAL,    &db_update, 0, 0, 0 },
+  {"no-u",             0,  POPT_ARG_VAL,    &db_update, 0, 0, 0 },
+  {"output",          'o', POPT_ARG_STRING, 0, 'o', 0, 0 },
+  {"recursive",       'r', POPT_ARG_VAL,    &recurse, 1, 0, 0 },
+  {"no-recursive",     0,  POPT_ARG_VAL,    &recurse, 0, 0, 0 },
+  {"no-r",             0,  POPT_ARG_VAL,    &recurse, 0, 0, 0 },
+  {"sums",            's', POPT_ARG_STRING, 0, 's', 0, 0 },
+  {"init",             0,  POPT_ARG_NONE,   &db_init, 0, 0, 0 },
+  {"mounts",           0,  POPT_ARG_NONE,   &db_mounts, 0, 0, 0 },
+  {"quiet",           'q', POPT_ARG_NONE,   &quiet, 0, 0, 0 },
+  {"help",            'h', POPT_ARG_NONE,   0, 'h', 0, 0 },
+  {"db-help",          0,  POPT_ARG_NONE,   0, 'h', 0, 0 },
+  {0,0,0,0, 0, 0, 0}
+};
 
 static char err_buf[200];
 
@@ -989,6 +1028,8 @@ static void set_refuse_options(void)
 			parse_one_refuse_match(0, "iconv", list_end);
 #endif
 		parse_one_refuse_match(0, "log-file*", list_end);
+		parse_one_refuse_match(0, "db", list_end);
+		parse_one_refuse_match(0, "db-lax", list_end);
 	}
 
 #ifndef SUPPORT_ATIMES
@@ -1296,6 +1337,102 @@ static void create_refuse_error(int which)
 		snprintf(err_buf + n, sizeof err_buf - n, " (-%c)\n", op->shortName);
 }
 
+static NORETURN void parse_dbonly_args(int argc, const char **argv)
+{
+	poptContext pc = poptGetContext(RSYNC_NAME, argc, argv, long_dbonly_options, 0);
+	const char *arg;
+	int opt;
+
+	recurse = 1;
+	am_dbadmin = 1;
+
+	while ((opt = poptGetNextOpt(pc)) != -1) {
+		const char *cp;
+		switch (opt) {
+		case 'o':
+			for (cp = poptGetOptArg(pc); *cp; cp++) {
+				switch (toLower(cp)) {
+				case 'n':
+					db_output_name = 1;
+					break;
+				case 's':
+				case 'c':
+					db_output_sum = db_output_name = 1;
+					break;
+				case 'i':
+					db_output_info = db_output_name = 1;
+					break;
+				case 'u':
+					db_output_unchanged = db_output_name = 1;
+					break;
+				case 'd':
+					db_output_dirs = 1;
+					break;
+				}
+			}
+			saw_db_output_opt = 1;
+			break;
+
+		case 's':
+			for (cp = poptGetOptArg(pc); *cp; cp++) {
+				switch (*cp) {
+				case '4':
+					db_do_md4 = 1;
+					break;
+				case '5':
+					db_do_md5 = 1;
+					break;
+				}
+			}
+			saw_db_sum_opt = 1;
+			break;
+
+		case 'h':
+			dbonly_usage(FINFO);
+			exit_cleanup(0);
+
+		case OPT_INFO:
+			arg = poptGetOptArg(pc);
+			parse_output_words(info_words, info_levels, arg, USER_PRIORITY);
+			break;
+
+		case OPT_DEBUG:
+			arg = poptGetOptArg(pc);
+			parse_output_words(debug_words, debug_levels, arg, USER_PRIORITY);
+			break;
+
+		default:
+			rprintf(FERROR,
+				"rsyncdb: %s: %s\n",
+				poptBadOption(pc, POPT_BADOPTION_NOALIAS),
+				poptStrerror(opt));
+			goto dbonly_usage;
+		}
+	}
+
+	if (!db_config) {
+		rprintf(FERROR, "You must specify the --db=FILE option.\n");
+	  dbonly_usage:
+		rprintf(FERROR,
+			"(Type \"rsyncdb --help\" for assistance.)\n");
+		exit_cleanup(RERR_SYNTAX);
+	}
+
+	if (!saw_db_output_opt && !quiet) {
+		db_output_dirs = db_output_name = 1;
+		if (db_check)
+			db_output_info = 1;
+	}
+	if (!quiet)
+		db_output_msgs = 1;
+	if (!saw_db_sum_opt)
+		db_do_md5 = 1;
+
+	am_starting_up = 0;
+	run_dbonly(poptGetArgs(pc));
+	exit(42); /* NOT REACHED */
+}
+
 /* This is used to make sure that --daemon & --server cannot be aliased to
  * something else. These options have always disabled popt aliases for the
  * parsing of a daemon or server command-line, but we have to make sure that
@@ -1352,6 +1489,12 @@ int parse_arguments(int *argc_p, const char ***argv_p)
 		return 0;
 	}
 
+	arg = *argv + strlen(*argv);
+	if (arg - *argv > 2 && strcmp(arg-2, "db") == 0) {
+		parse_dbonly_args(argc, argv);
+		/* NOT REACHED */
+	}
+
 	set_refuse_options();
 
 #ifdef ICONV_OPTION
@@ -1470,6 +1613,12 @@ int parse_arguments(int *argc_p, const char ***argv_p)
 			am_daemon = 1;
 			return 1;
 
+		case OPT_DBONLY:
+			protect_args = 0;
+			poptFreeContext(pc);
+			parse_dbonly_args(argc, argv);
+			break; /* NOT REACHED */
+
 		case OPT_MODIFY_WINDOW:
 			/* The value has already been set by popt, but
 			 * we need to remember that we're using a
@@ -1542,6 +1691,10 @@ int parse_arguments(int *argc_p, const char ***argv_p)
 			preserve_devices = preserve_specials = 0;
 			break;
 
+		case OPT_NO_DB:
+			db_config = NULL;
+			break;
+
 		case 'h':
 			human_readable++;
 			break;
diff --git a/pipe.c b/pipe.c
--- a/pipe.c
+++ b/pipe.c
@@ -27,11 +27,16 @@ extern int am_server;
 extern int blocking_io;
 extern int filesfrom_fd;
 extern int munge_symlinks;
+extern int always_checksum;
+extern int use_db;
+extern char *db_config;
 extern char *logfile_name;
 extern int remote_option_cnt;
 extern const char **remote_options;
 extern struct chmod_mode_struct *chmod_modes;
 
+int same_db = 0;
+
 /**
  * Create a child connected to us via its stdin/stdout.
  *
@@ -141,13 +146,22 @@ pid_t local_child(int argc, char **argv, int *f_in, int *f_out,
 		}
 
 		if (remote_option_cnt) {
+			const char *db_config_save = db_config;
 			int rc = remote_option_cnt + 1;
 			const char **rv = remote_options;
 			if (!parse_arguments(&rc, &rv)) {
 				option_error();
 				exit_cleanup(RERR_SYNTAX);
 			}
-		}
+			if (db_config == db_config_save)
+				same_db = db_config != NULL;
+			else if (!db_config || !db_config_save || strcmp(db_config, db_config_save) != 0) {
+				use_db = 0;
+				if (db_config)
+					db_read_config(FERROR, db_config);
+			}
+		} else if (use_db)
+			same_db = 1;
 
 		if (dup2(to_child_pipe[0], STDIN_FILENO) < 0
 		 || close(to_child_pipe[1]) < 0
diff --git a/receiver.c b/receiver.c
--- a/receiver.c
+++ b/receiver.c
@@ -24,6 +24,8 @@
 
 extern int dry_run;
 extern int do_xfers;
+extern int use_db;
+extern int db_lax;
 extern int am_root;
 extern int am_server;
 extern int inc_recurse;
@@ -439,6 +441,11 @@ static void handle_delayed_updates(char *local_name)
 					"rename failed for %s (from %s)",
 					full_fname(fname), partialptr);
 			} else {
+				if (use_db && !db_lax) {
+					STRUCT_STAT st;
+					if (do_lstat(fname, &st) == 0)
+						db_update_ctime(5, &st);
+				}
 				if (remove_source_files
 				 || (preserve_hard_links && F_IS_HLINKED(file)))
 					send_msg_int(MSG_SUCCESS, ndx);
@@ -548,6 +555,9 @@ int recv_files(int f_in, int f_out, char *local_name)
 	if (whole_file < 0)
 		whole_file = 0;
 
+	if (use_db && (append_mode == 1 || protocol_version < 30))
+		use_db = 0; /* We can't note finished md5 values */
+
 	progress_init();
 
 	while (1) {
@@ -895,6 +905,8 @@ int recv_files(int f_in, int f_out, char *local_name)
 					do_unlink(partialptr);
 				handle_partial_dir(partialptr, PDIR_DELETE);
 			}
+			if (use_db && do_lstat(fname, &st) == 0)
+				db_set_checksum(5, &st, sender_file_sum);
 		} else if (keep_partial && partialptr && (!one_inplace || delay_updates)) {
 			if (!handle_partial_dir(partialptr, PDIR_CREATE)) {
 				rprintf(FERROR,
@@ -908,6 +920,8 @@ int recv_files(int f_in, int f_out, char *local_name)
 				recv_ok = -1;
 			else if (delay_updates && recv_ok) {
 				bitbag_set_bit(delayed_bits, ndx);
+				if (use_db && do_lstat(partialptr, &st) == 0)
+					db_set_checksum(5, &st, sender_file_sum);
 				recv_ok = 2;
 			} else
 				partialptr = NULL;
diff --git a/rsync.c b/rsync.c
--- a/rsync.c
+++ b/rsync.c
@@ -41,6 +41,7 @@ extern int am_daemon;
 extern int am_sender;
 extern int am_receiver;
 extern int am_generator;
+extern int am_dbadmin;
 extern int am_starting_up;
 extern int allow_8bit_chars;
 extern int protocol_version;
@@ -819,6 +820,8 @@ struct file_list *flist_for_ndx(int ndx, const char *fatal_error_loc)
 
 const char *who_am_i(void)
 {
+	if (am_dbadmin)
+		return "rsyncdb";
 	if (am_starting_up)
 		return am_server ? "server" : "client";
 	return am_sender ? "sender"
diff --git a/rsync.h b/rsync.h
--- a/rsync.h
+++ b/rsync.h
@@ -271,6 +271,7 @@ enum msgcode {
 	MSG_IO_ERROR=22,/* the sending side had an I/O error */
 	MSG_IO_TIMEOUT=33,/* tell client about a daemon's timeout value */
 	MSG_NOOP=42,	/* a do-nothing message (legacy protocol-30 only) */
+	MSG_CHECKSUM=55,/* sent via rcvr -> gen pipe and local-host-only gen -> sender */
 	MSG_ERROR_EXIT=86, /* synchronize an error exit (siblings and protocol >= 31) */
 	MSG_SUCCESS=100,/* successfully updated indicated flist index */
 	MSG_DELETED=101,/* successfully deleted a file on receiving side */
@@ -281,6 +282,9 @@ enum filetype {
 	FT_UNSUPPORTED, FT_REG, FT_DIR, FT_SYMLINK, FT_SPECIAL, FT_DEVICE
 };
 
+#define MSG_CHECKSUM_LONGS 5
+#define MSG_CHECKSUM_LEN (MSG_CHECKSUM_LONGS*8 + 4 + MAX_DIGEST_LEN)
+
 #define NDX_DONE -1
 #define NDX_FLIST_EOF -2
 #define NDX_DEL_STATS -3
@@ -1438,7 +1442,8 @@ extern short info_levels[], debug_levels[];
 #define DEBUG_CHDIR (DEBUG_BIND+1)
 #define DEBUG_CONNECT (DEBUG_CHDIR+1)
 #define DEBUG_CMD (DEBUG_CONNECT+1)
-#define DEBUG_DEL (DEBUG_CMD+1)
+#define DEBUG_DB (DEBUG_CMD+1)
+#define DEBUG_DEL (DEBUG_DB+1)
 #define DEBUG_DELTASUM (DEBUG_DEL+1)
 #define DEBUG_DUP (DEBUG_DELTASUM+1)
 #define DEBUG_EXIT (DEBUG_DUP+1)
diff --git a/rsyncdb-mountinfo b/rsyncdb-mountinfo
new file mode 100755
--- /dev/null
+++ b/rsyncdb-mountinfo
@@ -0,0 +1,82 @@
+#!/usr/bin/perl
+
+# This script outputs data for rsyncdb --mounts.  It must output a complete
+# list of the mounts for the current host in a strict format -- 2 fields
+# with a Tab between:  $MOUNT_UNIQ\t$PATH
+#
+# The list of mounts MUST NOT contain any entry that has the same devnum
+# (st_dev) as any other entry in the list (as checked via its PATH).
+#
+# MOUNT_UNIQ is a unique string that identifies the mount on this host.
+# This cannot be the devnum (st_dev) because that can vary depending on the
+# mount order or be reused for different mounts if they are not mounted at
+# the same time.  Ideally this would be its UUID value, if that is available
+# on this OS.  This script looks in /dev/disk/by-uuid for the current UUID
+# mappings).  If the UUID is not found, the fallback default is the string
+# "Mount of $devname", which should be adequate for situations that don't
+# use removable media (though you may need to take steps to weed-out removable
+# mounts).
+#
+# You can override the MOUNT_UNIQ value by putting a .rsyncdb_mount_uniq
+# file in the root directory of any mount, at which point it is up to you
+# to make sure that the value stays unique (note that all sequences of
+# whitespace are transformed into a single space, and leading/trailing
+# whitespace is removed).
+#
+# MOUNT_UNIQ may never contain a Tab but it would be legal for PATH to have
+# a Tab (just really weird).  Neither may have a CR or LF in it.
+#
+# The maximum size for MOUNT_UNIQ is 256 characters.
+#
+# If this script doesn't meet your needs, feel free to edit/replace it and
+# choose some other method of finding a unique value for each mount.  If you
+# come up with a good idiom that might be useful to others, please share it
+# with the rsync mailing list.
+
+use strict;
+use warnings;
+use Cwd 'abs_path';
+
+my @MOUNT_FILES = qw( /proc/mounts /etc/mtab );
+my $VALID_DEVICE_REGEX = qr{^/dev|^rootfs$};
+my $UUID_DIR = '/dev/disk/by-uuid';
+my $OVERRIDE_FILE = '.rsyncdb_mount_uniq';
+
+my (%hash, %uuid);
+
+if (-d $UUID_DIR) {
+    foreach my $uuid (glob "$UUID_DIR/*") {
+	my $lnk = readlink($uuid);
+	if ($lnk !~ m{^/}) {
+	    $lnk = abs_path("$UUID_DIR/$lnk");
+	}
+	$uuid =~ s{.*/}{};
+	$uuid{$lnk} = $uuid;
+    }
+}
+
+foreach my $mount_file (@MOUNT_FILES) {
+    if (open MOUNTS, $mount_file) {
+	while (<MOUNTS>) {
+	    my ($devname, $path) = (split)[0,1];
+	    next unless $devname =~ /$VALID_DEVICE_REGEX/;
+
+	    my ($devno) = (stat($path))[0];
+	    next unless defined $devno; # Skip if mount is invalid.
+	    next if $hash{$devno}++; # SKip if we've seen this devno earlier.
+
+	    my $mount_uniq = $uuid{$devname} ? $uuid{$devname} : "Mount of $devname";
+	    if (open UNIQ, '<', "$path/$OVERRIDE_FILE") {
+		$mount_uniq = <UNIQ>;
+		close UNIQ;
+		$mount_uniq =~ s/\s+/ /g; # This ensures no tab, CR, nor LF.
+		$mount_uniq =~ s/^ | $//g; # .. and no leading or trailing whitespace.
+	    }
+	    print $mount_uniq, "\t", $path, "\n";
+	}
+	close MOUNTS;
+	exit;
+    }
+}
+
+die "Failed to to open any mount files: @MOUNT_FILES\n";
diff --git a/usage.c b/usage.c
--- a/usage.c
+++ b/usage.c
@@ -137,6 +137,16 @@ static void print_info_flags(enum logcode f)
 #endif
 			"crtimes",
 
+#if !defined HAVE_MYSQL_MYSQL_H || !defined HAVE_LIBMYSQLCLIENT
+		"no "
+#endif
+			"MySQL",
+
+#if !defined HAVE_SQLITE3_H || !defined HAVE_LIBSQLITE3
+		"no "
+#endif
+			"SQLite",
+
 	"*Optimizations",
 
 #ifndef USE_ROLL_SIMD
@@ -261,6 +271,14 @@ void daemon_usage(enum logcode F)
   rprintf(F,"daemon-specific rsync options.  See also the rsyncd.conf(5) manpage.\n");
 }
 
+void dbonly_usage(enum logcode F)
+{
+  rprintf(F,"Usage: rsyncdb --db=CONFIG_FILE [OPTIONS] [DIRS]\n");
+  rprintf(F,"\n");
+  rprintf(F,"Options:\n");
+#include "help-rsyncdb.h"
+}
+
 const char *rsync_version(void)
 {
 #ifdef RSYNC_GITVER
diff -Nurp a/config.h.in b/config.h.in
--- a/config.h.in
+++ b/config.h.in
@@ -225,6 +225,9 @@
 /* Define to 1 if you have the `inet' library (-linet). */
 #undef HAVE_LIBINET
 
+/* Define to 1 if you have the `mysqlclient' library (-lmysqlclient). */
+#undef HAVE_LIBMYSQLCLIENT
+
 /* Define to 1 if you have the `nsl' library (-lnsl). */
 #undef HAVE_LIBNSL
 
@@ -243,6 +246,9 @@
 /* Define to 1 if you have the `socket' library (-lsocket). */
 #undef HAVE_LIBSOCKET
 
+/* Define to 1 if you have the `sqlite3' library (-lsqlite3). */
+#undef HAVE_LIBSQLITE3
+
 /* Define to 1 if you have the `z' library (-lz). */
 #undef HAVE_LIBZ
 
@@ -320,6 +326,9 @@
 /* Define to 1 if you have the `mtrace' function. */
 #undef HAVE_MTRACE
 
+/* Define to 1 if you have the <mysql/mysql.h> header file. */
+#undef HAVE_MYSQL_MYSQL_H
+
 /* Define to 1 if you have the `nanosleep' function. */
 #undef HAVE_NANOSLEEP
 
@@ -443,6 +452,15 @@
 /* True if you have Solaris xattrs */
 #undef HAVE_SOLARIS_XATTRS
 
+/* Define to 1 if you have the <sqlite3.h> header file. */
+#undef HAVE_SQLITE3_H
+
+/* Define to 1 if you have the `sqlite3_open_v2' function. */
+#undef HAVE_SQLITE3_OPEN_V2
+
+/* Define to 1 if you have the `sqlite3_prepare_v2' function. */
+#undef HAVE_SQLITE3_PREPARE_V2
+
 /* Define to 1 if you have the <stdint.h> header file. */
 #undef HAVE_STDINT_H
 
